﻿using System.Runtime.Serialization;
using System;
using Flatland.GeneticProgramming.CoreTypes;

/**
* 
* Copyright (c) 2012 Anders Høst Kjærgaard | ahkj@itu.dk
*  
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
* associated documentation files (the "Software"), to deal in the Software without restriction, 
* including without limitation the rights to use, copy, modify, merge, publish, distribute, 
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial 
* portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
* NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

namespace Flatland.GeneticProgramming.TestProblems_Do_not_modify
{
    //Test problem similar to TestProb, but with different function names
    public class TestGene3 : GenoType, IExpression<int>
    {
        [Primitive]
        public int Black;

        [Primitive]
        public int White;

        //[Primitive]
        public static int[] c3 = new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 0 };

        [Primitive]
        public int Yellow(int x, int y) { return x + y; }

        [Primitive]
        public int Red(int x, int y) { return x - y; }

        [Primitive]
        public int Green(int x, int y) { return x * y; }

        [Primitive]
        public int Blue(int x, int y) { return y == 0 ? x : x % y; }

        [Primitive]
        public int Orange(int x, int y) { return y == 0 ? 1 : x / y; }

        public override double Fitness()
        {
            return (double) Execute();
        }

        public override object Clone()
        {
            return new TestGene3();
        }


        protected override void Act(ref string msg)
        {
            throw new NotImplementedException();
        }
    }
}
