﻿/**
* 
* Copyright (c) 2012 Anders Høst Kjærgaard | ahkj@itu.dk
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
* associated documentation files (the "Software"), to deal in the Software without restriction, 
* including without limitation the rights to use, copy, modify, merge, publish, distribute, 
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial 
* portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
* NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

using System;
using Flatland.GeneticProgramming.CoreTypes;

namespace Flatland.GeneticProgramming.TestProblems_Do_not_modify {
    /// <summary>
    /// Class for testing purposes. Please do not modify as test assume certain things about this class.
    /// There are example classes in the Examples folder.
    /// to create new test just add new test classes.
    /// </summary>
    public class TestGene4 : GenoType, IExpression<int> {

        /**
         * UNIT TEST WILL LOOK FOR CERTAIN AMOUNT OF TERMINALS
         * 1 terminals
         */
        [Primitive]  //1
        public int X;

        [Primitive] //Not valid Primitive by convention
        public double Z;

        [Primitive] //Not valid Primitive by convention
        public bool b;

        /**
        * UNIT TEST WILL LOOK FOR CERTAIN AMOUNT OF FUNCTIONS
         * 1 function
        */
        [Primitive]
        public int Add(int x, int y) { return x + y; }


        public override double Fitness() {
            return 42;

        }

        public override object Clone()
        {
            return new TestGene4();
        }

        protected override void Act(ref string msg)
        {
            throw new NotImplementedException();
        }
    }
}

