﻿using System;
using Flatland.GeneticProgramming.CoreTypes;


/**
* 
* Copyright (c) 2012 Anders Høst Kjærgaard | ahkj@itu.dk
* 
* 
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
* associated documentation files (the "Software"), to deal in the Software without restriction, 
* including without limitation the rights to use, copy, modify, merge, publish, distribute, 
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial 
* portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
* NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

namespace Flatland.GeneticProgramming.TestProblems_Do_not_modify_ {
    [Serializable]
    public class TestGeneCommand : GenoType {
        private int _foodFound;

        [Primitive]
        public bool FoodAhead;

        [Primitive]
        public bool IsHungry() {
            return true;
        }

        [Primitive]
        public void Move() {}


        [Primitive]
        public bool IsFacingFood() {
            return true;
        }

        public override double Fitness() {
            _foodFound = 0;
            return _foodFound;
        }


        public virtual void Execute() { }

        public override object Clone() {
            return new TestGeneCommand();
        }

        protected override void Act(ref string msg)
        {
            throw new NotImplementedException();
        }
    }
}
