/**
 * 
 * Copyright (c) 2012 Anders Hst Kjrgaard | ahkj@itu.dk
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
 * associated documentation files (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge, publish, distribute, 
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial 
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT 
 * NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

using System;
using Flatland.GeneBank;
using Flatland.GeneticProgramming;
using Flatland.GeneticProgramming.CoreTypes;
using Flatland.GeneticProgramming.Examples;
using Flatland.GeneticProgramming.Mutations;
using Flatland.Labs;

namespace Flatland {
    //#if WINDOWS || XBOX
    /// <summary>
    /// Main class for Flatland
    /// </summary>
    class Program {
        public static string GENE_FILE_EXTENSION = ".Gene";
        public static readonly string MY_GENES_FOLDER = "GeneBank";

        /// <summary>
        /// Global reference to Flatland
        /// </summary>
        public static FlatlandWorld FlatlandWorld;

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main(string[] args) {
            /*
             * Train a food finder genetype.
             * Max generations, population and mutation rate are high for demo
             */
            //FindFood findFood = new FindFood();
            //FlatlandLab lab = new FoodLab(new GP(findFood, FoodLab.AMOUNT_OF__TEST_FOOD, 3, 3, 4, mutationRate: 1));
            //FlatlandWorld = new FlatlandWorld(lab);
            //return;

            /*
             * Example of a program that outputs a string
             * See StringExample.cs
             */
             //GP gp = new GP(new StringExample(), populationSize: 50, maxTreeDepth: 7, maxGenerations: 10000, mutationRate: 0.50);
             //gp.IgnoresOutput = true;
             //StringExample solution = (StringExample)gp.Run();
             //Console.WriteLine("Result " + solution.Execute());
             //Console.ReadKey();
             //return;


            FlatlandWorld = new FlatlandWorld();
            FlatlandWorld.Run();
        }
    }
    //#endif
}

