﻿using Flatland.AgentBehavior;
using Flatland.GeneticProgramming;
using Flatland.GeneticProgramming.Examples;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Flatland;

namespace Test
{
    
    
    /// <summary>
    ///This is a test class for GenomeTest and is intended
    ///to contain all Behavior Unit Tests.
    /// TODO create tests.
    ///</summary>
    [TestClass()]
    public class BehaviorTest {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext {
            get {
                return testContextInstance;
            }
            set {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for BehaviorFactory. Simple test that some Behavior return is that of the first gene it is sent
        ///</summary>
        [TestMethod()]
        public void GetBaseBehaviorTest() {
            GP ceb1 = new GP(new MathExample(), 42,1);
            ceb1.Init();
            Agent a1 = new Agent();
            
            Behavior actual;
            actual = Behavior.BehaviorFactory(a1, ceb1.Population);
            Assert.IsNotNull(actual, "Get base Behavior returned null when called with 1 GenoType");
            Assert.IsTrue(actual == a1.Reports[0].GenoType, "Single gene set to Behavior has changed after call");
        }
    }
}
